/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Direct-writing video routines                                          *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 *  (Very) Loosely based on the public-domain routines originally          *
 *  written by Scott Friedman, in his FASTVID.C.  Although I               *
 *  doubt that Scott would recognize them now, since they've               *
 *  been hacked to pieces and speeded up by several magnitudes             *
 *  by re-coding everything in assembly language and                       *
 *  re-thinking the algorithm, these routines wouldn't be here             *
 *  today without his original contribution.                               *
 *                                                                         *
 ***************************************************************************/

#ifdef OS_2
#pragma message(__FILE__ " is for DOS mode only")
#else

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include "prog.h"
#include "max.h"

#ifndef __TURBOC__
#define MK_FP(seg, off)  (void far *)((unsigned long)(seg)<<16L | (off))
#endif

#define MONOMEM     MK_FP(0xb000,0x0000)
#define CGAMEM      MK_FP(0xb800,0x0000)

#define NUM_COLS    (*((unsigned int far *)MK_FP(0x0000,0x044a)))
#define BUFFER_LEN  (*((unsigned int far *)MK_FP(0x0000,0x044c)))


int * near RowTable=NULL;         /* Table of row offsets                  */

char far * near Vid_Display;      /* Base segment for video IO             */

int near Vid_StatusPort,          /* Port to check for retrace             */
         Vid_HaveSnow,            /* If we should check for snow or not    */
         Vid_MonoCard,            /* MDA?                                  */
         Vid_NumRows,             /* Number of rows, total                 */
         Vid_NumCols,             /* Number of columns, total              */
         Vid_Row,                 /* Current row                           */
         Vid_Col,                 /* Current column                        */
         Vid_Segment=0xb000,      /* Segment the video buffer is in        */
         Vid_TotChars;            /* Total # of chars on screen            */

char near Vid_Page,               /* Current video page number (CGA only)  */
          Vid_Attribute,          /* Current attribute                     */
          Vid_Open;               /* If we've been init'ed or not          */

void GetxyB (int *Row,int *Col)
{
    union REGS regs;

    regs.h.ah = 3;
    regs.h.bh = Vid_Page;
    int86(0x10, &regs, &regs);
    *Row = regs.h.dh;
    *Col = regs.h.dl;
}

void cdecl VidPuts(char *Text)
{
  while (*Text)
    VidPutc(*Text++);
}

/*
void pascal VidPutc(char ch)
{
  char c[2];

  *c=ch;
  *(c+1)='\0';
  VidPuts(c);
}
*/

int pascal VidOpen(int has_snow,int desqview,int dec_rows)
{
  int x,y;

  Vid_Open=TRUE;

  Vid_MonoCard=(VidGetMode()==7);

  if (VidGetMode() != 3 && !Vid_MonoCard)
    VidSetMode(3);

  Vid_NumCols=NUM_COLS;
  Vid_NumRows=(BUFFER_LEN/NUM_COLS) >> 1;

  /* Fix off-by-one errors that may be exhibited by some video modes */

  switch(Vid_NumRows)
  {
    case 26:
    case 44:
    case 51:
    case 61:
      Vid_NumRows--;
      break;
  }

  Vid_TotChars=Vid_NumCols*Vid_NumRows;

  Vid_Segment=VidGetBuffer(Vid_MonoCard);

  if (desqview)
    Start_Shadow();

  Vid_Display=MK_FP(VidGetBuffer(Vid_MonoCard),0);

  Vid_StatusPort=(Vid_MonoCard ? 0x3BA : 0x3DA);
  Vid_HaveSnow=has_snow;

  if (VidGetBPage() != 0)
    VidSetPage(0);

  Vid_Page=0;

  VidSetAttr(7);

  GetxyB(&Vid_Row,&Vid_Col);

  if ((RowTable=(int *)malloc(Vid_NumRows*sizeof(int)))==NULL)
  {
    Vid_Open=FALSE;
    return -1;
  }

  for (x=y=0;x < Vid_NumRows;x++)
  {
    RowTable[x]=y;
    y += Vid_NumCols*sizeof(int);
  }

  /* Status-line? */
  if (dec_rows)
  {
    Vid_NumRows--;

    if (Vid_Row >= Vid_NumRows)
    {
      VidScroll(SCROLL_up,1,Vid_Attribute,0,0,(char)Vid_NumCols-1,(char)Vid_NumRows);
      Vid_Row=Vid_NumRows-1;
    }
  }

  return 0;
}

int pascal VidClose(int desqview)
{
  if (Vid_Open)
  {
    if (desqview)
      End_Shadow();

    Vid_Open=FALSE;
    VidSync();
    sfree(RowTable);
    return 0;
  }
  else return -1;
}


int pascal VidGotoXY(int Col,int Row,int do_sync)
{
  Col--;
  Row--;

  if (!do_sync || (Col >= 0 && Col < Vid_NumCols && Row >= 0 && Row < Vid_NumRows))
  {
    Vid_Col=Col;
    Vid_Row=Row;

    if (do_sync)
      VidSync();

    return 0;
  }
  else return -1;
}


void pascal VidGetXY(int *Col,int *Row)
{
  *Col=Vid_Col+1;
  *Row=Vid_Row+1;
}


int pascal VidNumRows(void)
{
  return Vid_NumRows;
}

int pascal VidWhereX(void)
{
  return Vid_Col+1;
}

int pascal VidWhereY(void)
{
  return Vid_Row+1;
}

void pascal VidCls(char Attribute)
{
  VidScroll(SCROLL_up,0,Attribute,0,0,(char)Vid_NumCols-1,(char)Vid_NumRows-1);
  VidGotoXY(1,1,TRUE);
}

char pascal VidGetAttr(void)
{
  return Vid_Attribute;
}

void pascal VidSetAttr(char Attribute)
{
  Vid_Attribute=Attribute;
}

char pascal VidGetPage(void)
{
  return Vid_Page;
}



#ifdef NEVER
void pascal Say (char *Text)
{
  unsigned long Offset = 0L;

  Offset = (RowTable[Vid_Row]+(Vid_Col << 1));

  while (*Text != '\0')
  {
    if (++Vid_Col > 80)
    {
      Vid_Col=1;

      if (++Vid_Row >= Vid_NumRows-1)
      {
        Vid_Row++;
        VidScrollUp(&Vid_Col,&Vid_Row);
        Offset=(RowTable[Vid_Row]+((Vid_Col-1) << 1 ));
      }
    }


    if (Vid_HaveSnow)
    {
      while ((inp(Vid_StatusPort) & 0x01) != 0)
        ;

      while ((inp(Vid_StatusPort) & 0x01)==0)
        ;
    }

    *(Vid_Display+Offset++)=*Text++;
    *(Vid_Display+Offset++)=Vid_Attribute;
  }
}


void pascal SetCursor ( char Start, char End ) {
     _AH = 0x01;
     _CH = Start;
     _CL = End;
     geninterrupt ( 0x10 );
}


void pascal HideCursor ( void ) {
     GotoxyB ( 0, 25 );
}


void pascal ShowCursor ( void ) {
     GotoxyB ( Vid_Col, Vid_Row );
}

void pascal ScrollUp(int *Col,int *Row)
{
  Scroll(UP,*Row-Vid_NumRows+1,Vid_Attribute,0,0,Vid_NumCols,Vid_NumRows);
  *Row=Vid_NumRows-2;
  *Col=1;
}




void pascal GotoxyB ( int Col, int Row ) {
     _AH = 0x02;
     _BH = Vid_Page;
     _DH = Row;
     _DL = Col;
     geninterrupt ( 0x10 );
}

void pascal SetPage ( char Page ) {
     if ( ! Vid_MonoCard ) {
          _AH = 0x05;
          _AL = Page;
          geninterrupt ( 0x10 );
          Vid_Page = Page;
     }
}

char pascal GetPage ( void ) {
     return ( Vid_Page );
}

int pascal GetVideoMode ( void ) {
     _AH = 0x0F;
     geninterrupt ( 0x10 );
     return ( _AL );
}

void pascal SetVideoMode ( char Mode ) {
     _AH = 0x00;
     _AL = Mode;
     geninterrupt ( 0x10 );
}

void pascal Scroll ( char Direction, char NumOfLines, char Attribute, int x1, int y1, int x2, int y2 ) {
     _AH = Direction;
     _AL = NumOfLines;
     _BH = Attribute;
     _CH = y1;
     _CL = x1;
     _DH = y2;
     _DL = x2;
     geninterrupt ( 0x10 );
}


void pascal AtFlipAttribute ( int Col, int Row, char Attribute, int Number ) {
     Gotoxy ( Col, Row );
     FlipAttribute ( Attribute, Number );
}

void pascal SayA ( char *Text, char Attribute ) {
     char TempAttr;

     TempAttr = VidGetAttr (void);
     VidSetAttr ( Attribute );
     VidPuts ( Text );
     VidSetAttr ( TempAttr );
}


void pascal AtSay ( int Col, int Row, char *Text ) {
     if ( VidGotoXY ( Col, Row ) )
          VidPuts ( Text );
}


void pascal AtSayA ( int Col, int Row, char *Text, char Attribute ) {
     char TempAttr;

     TempAttr = VidGetAttr (void);
     VidSetAttr ( Attribute );
     AtSay ( Col, Row, Text );
     VidSetAttr ( TempAttr );
}


void pascal SayC ( char Character ) {
     char TempStr [ 2 ];

     TempStr [ 0 ] = Character;
     TempStr [ 1 ] = NULL;
     Say ( TempStr );
}


void pascal AtSayC ( int Col, int Row, char Character ) {
     Gotoxy ( Col, Row );
     SayC ( Character );
}


void pascal SayCN ( char Character, int Number ) {
     register i;
     char TempStr [ 2 ];

     TempStr [ 0 ] = Character;
     TempStr [ 1 ] = NULL;
     for ( i=0; i<Number; i++ )
          Say ( TempStr );
}


void pascal AtSayCN ( int Col, int Row, char Character, int Number ) {
     Gotoxy ( Col, Row );
     SayCN ( Character, Number );
}


void pascal AtSayCNV ( int Col, int Row, char Character, int Number ) {
     register i;

     for ( i=0; i<Number; i++ )
          AtSayC ( Col, Row + i, Character );
}

void pascal VidFlipAttr(char Attribute,int Number)
{
  unsigned long Offset=0L;

  Offset=(RowTable[Vid_Row]+(Vid_Col << 1))+1;

  while (Number--)
  {
    if (Vid_HaveSnow)
    {
      while ((inp(Vid_StatusPort) & 0x01) != 0)
        ;

      while ((inp(Vid_StatusPort) & 0x01)==0)
        ;
    }

    *(Vid_Display+Offset)=(char)Attribute;
    Offset += 2;
  }
}


#endif /* NEVER */
#endif /* OS_2 */

